// -- Main methods ------------------------------------------------------------

function _package(templateName, table) {
    // -- create the variables
    var template = pack.getTemplate(templateName);
    var resource = util.createResource();
    
    // -- add resource parts
    resource.add(target.getPackage());
    resource.add(template.getTarget().getPackage());
    
    if (table instanceof net.sf.sql2java.common.beans.Processable) {
        var parent = table.getParent();
        
        while (parent != null) {
            resource.addParameter(parent.getKey(), parent);
            
            parent = parent.getParent();
        }   
    }
    
    // -- return the parsed result
    return resource.getPackage();
}

function _class(templateName, entity) {
    // -- create the variables
    var template = pack.getTemplate(templateName);
    var ps = util.createParameterString("?{" + template.getTarget().getFilename() + "@ca}");
    
    // -- add a parameter
    ps.addParameter("table", entity);
    
    // -- return the parsed result
    return ps.parse();
}

// -- Beans -------------------------------------------------------------------

function beanPackage(entity) {
    return _package("commonBean", entity);
}

function beanClass(entity) {
    return _class("commonBean", entity);
}

function beanVariable(entity) {
    return convertor.convertToVariable("tmpBean", entity);
}


// -- Keys --------------------------------------------------------------------

function keyPackage(entity) {
    return _package("commonKey", entity);
}

function keyClass(entity) {
    return _class("commonKey", entity);
}


// -- Dao's -------------------------------------------------------------------

function daoPackage(entity) {
    return _package("commonDao", entity);
}

function daoClass(entity) {
    return _class("commonDao", entity);
}

function daoVariable(entity) {
    return convertor.convertToVariable("tmpDao", entity);
}


// -- IBatis Dao's ------------------------------------------------------------

function daoIBatisPackage(entity) {
    return convertor.convertToPackage("tmpDaoIBatis", entity);
}

function daoIBatisClass(entity) {
    return convertor.convertToClass("tmpDaoIBatis", entity);
}


// -- IBatis Mappings ---------------------------------------------------------

function sqlMapFullFile(entity) {
    return convertor.convertToFullJavaFile("tmpSqlMap", entity);
}

function sqlMapPackage(entity) {
    return convertor.convertToPackage("tmpSqlMap", entity);
}

function sqlMapFile(entity) {
    return convertor.convertToFile("tmpSqlMap", entity);
}

function confClass(schema) {
    return convertor.convertToFullJavaFile("tmpSqlMapConfig", schema);
}